//+++======================================================================+++
//+++                   21x2 Indexes +2xMA MTF TT Eng                      +++
//+++======================================================================+++
#property copyright   "  Tankk,  17  October  2016,  http://forexsystems.ru/" 
#property link        "http://forexsystemsru.com/indikatory-foreks/70042-kak-sdelat`-samomu-trendovyi-indikator.html"
#property description "AC, AO, AD, ADX, ATR, Bears, Bulls, CCI, DMR, Force, MA, OCLH, DPO, MFI, BWMFI, MMNT, OBV, RSI, RVI, STD, WPR  --        ." 
#property description "    MT4."
#property description "Moving Average      ,     .   Moving Averages    :))"
#property description " ,  MTF    ." 
#property version  "1.00"
//#property strict
#property indicator_separate_window
#property indicator_buffers 4

#property indicator_color1  LightSteelBlue 
#property indicator_color2  DodgerBlue    //Green   //LightCyan   //RoyalBlue    //Blue
#property indicator_color3  Gold        //OrangeRed    //Red  //Gold
#property indicator_color4  OrangeRed

#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  2
#property indicator_width4  2

#property indicator_level1 -100
#property indicator_level2 100
#property indicator_level3 50
#property indicator_level4 0

#property indicator_levelcolor DarkGreen   //DarkSlateGray // SteelBlue //C'60,61,62' // 
#property indicator_levelstyle STYLE_DOT

/*#property indicator_minimum -100
#property indicator_maximum 0*/

enum calc { AC, AO, AD, ADX, ATR, Bears, Bulls, CCI, DMR, Force, MA, OCLH, DPO, MFI, BWMFI, MMNT, OBV, RSI, RVI, STD, WPR };
enum ind1 { Line1, Histo1, Dots1 };
enum ind2 { Line2, Histo2, Dots2 };
//+++======================================================================+++
//+++                 Custom indicator input parameters                    +++
//+++======================================================================+++

extern int                History  =  0;      //    
extern calc           Calculation  =  MFI;    //  

extern ENUM_TIMEFRAMES       MTF1  =  PERIOD_H1;        //    
extern int                Period1  =  15,               //  
                           Shift1  =  0;                //  
extern ENUM_MA_METHOD     Method1  =  MODE_LWMA;        //  
extern ENUM_APPLIED_PRICE  Price1  =  PRICE_WEIGHTED;    //  
extern int                 SigMA1  =  15,               //    
                         MA1Shift  =  0;                //  
extern ENUM_MA_METHOD   MA1Method  =  MODE_LWMA;        //  

extern ENUM_TIMEFRAMES       MTF2  =  PERIOD_CURRENT;   //    
extern int                Period2  =  15,               //  
                           Shift2  =  0;                //  
extern ENUM_MA_METHOD     Method2  =  MODE_LWMA;        //  
extern ENUM_APPLIED_PRICE  Price2  =  PRICE_WEIGHTED;    //  
extern int                 SigMA2  =  15,               //    
                         MA2Shift  =  0;                //  
extern ENUM_MA_METHOD   MA2Method  =  MODE_LWMA;        //  

extern ind1            DrawIndex1  =  Dots1;           //   ...
extern ind2            DrawIndex2  =  Dots2;           //   ...
extern int              DotsCode1  =  159,             //     
                        DotsCode2  =  167;             //     

//+++======================================================================+++
//+++                     Custom indicator buffers                         +++
//+++======================================================================+++
double BUF1[], BUF2[], MA1[], MA2[];
//+++======================================================================+++
//+++              Custom indicator initialization function                +++
//+++======================================================================+++

int init()
{
  	IndicatorBuffers(4);   IndicatorDigits(Digits);   if (Digits==3 || Digits==5) IndicatorDigits(Digits-1);
//---- 4    
   SetIndexBuffer(0,BUF1);   
   SetIndexBuffer(1,BUF2);      
   SetIndexBuffer(2,MA1);      
   SetIndexBuffer(3,MA2);      
//----    
   int LT1=DRAW_LINE;    if (DrawIndex1==Histo1) LT1=DRAW_HISTOGRAM;   if (DrawIndex1==Dots1) LT1=DRAW_ARROW;     
   int LT2=DRAW_LINE;    if (DrawIndex2==Histo2) LT2=DRAW_HISTOGRAM;   if (DrawIndex2==Dots2) LT2=DRAW_ARROW;   
   SetIndexStyle(0,LT1);   SetIndexArrow(0,DotsCode1);                 
   SetIndexStyle(1,LT2);   SetIndexArrow(1,DotsCode2);             
   SetIndexStyle(2,DRAW_LINE);            
   SetIndexStyle(3,DRAW_LINE);    
//----  0    
  	SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   SetIndexEmptyValue(2,0.0);
   SetIndexEmptyValue(3,0.0); 
//---     
   SetIndexShift(0,Shift1);   
   SetIndexShift(1,Shift2);   
   SetIndexShift(2,MA1Shift);   
   SetIndexShift(3,MA2Shift);
////---    
   SetIndexDrawBegin(0,Shift1+Period1);   
   SetIndexDrawBegin(1,Shift2+Period2);   
   SetIndexDrawBegin(2,MA1Shift+SigMA1);   
   SetIndexDrawBegin(3,MA2Shift+SigMA2);
//----   DataWindow 
   SetIndexLabel(0, EnumToString(Calculation) + "  ["+IntegerToString(Period1)+ "]");
   SetIndexLabel(1, EnumToString(Calculation) + "  ["+IntegerToString(Period2)+ "]");
   SetIndexLabel(2, "SigMA1  ["+IntegerToString(SigMA1)+ "] ");
   SetIndexLabel(3, "SigMA2  ["+IntegerToString(SigMA2)+ "] ");

//---- " "  DataWindow    
   IndicatorShortName(WichPeriod(MTF1)+" - "+EnumToString(Calculation) + " ["+IntegerToString(Period1)+"-->"+IntegerToString(SigMA1)+"] vs "+WichPeriod(MTF2)+" - "+EnumToString(Calculation) + " ["+IntegerToString(Period2)+"-->"+IntegerToString(SigMA2)+"]");

//----
return(0);
}
//+++======================================================================+++
//+++              Custom indicator deinitialization function              +++
//+++======================================================================+++
int deinit() { return(0); }
//+++======================================================================+++
//+++                 Custom indicator iteration function                  +++
//+++======================================================================+++

int start()
{
   int  i, f, s,  counted_bars = IndicatorCounted();
   if (counted_bars < 0)  return(-1);
     if (History < 1)  History = Bars;         //Tankk-...
     if (counted_bars > 0)  counted_bars -= 0;
       int limit = MathMin(History-counted_bars,History-1); 
       if (limit <= 0)  limit = 1;          
//+++======================================================================+++
//+++                   21x2 Indexes +2xMA MTF TT Eng                      +++
//+++======================================================================+++
//enum calc { AC, AO, AD, ADX, ATR, Bears, Bulls, CCI, DMR, Force, MA, OCLH, DPO, MFI, BWMFI, MMNT, OBV, RSI, RVI, STD, WPR };
   
   for (i=limit; i >= 0; i--)  
    {
//---
     if (Period1==0)  BUF1[i]=0;     if (Period2==0)  BUF2[i]=0;
     //---
     f = iBarShift(NULL,MTF1,Time[i],false);   
     s = iBarShift(NULL,MTF2,Time[i],false);  
     //---
     if (Calculation==AC)    { BUF1[i] = iAC(NULL,MTF1,f+Shift1);
                               BUF2[i] = iAC(NULL,MTF2,s+Shift2); }
     //---
     if (Calculation==AO)    { BUF1[i] = iAO(NULL,MTF1,f+Shift1);
                               BUF2[i] = iAO(NULL,MTF2,s+Shift2); }
     //---
     if (Calculation==AD)    { BUF1[i] = iAD(NULL,MTF1,f+Shift1);
                               BUF2[i] = iAD(NULL,MTF2,s+Shift2); }
     //---
     if (Calculation==ADX)   { BUF1[i] = iADX(NULL,MTF1,Period1,Price1,MODE_PLUSDI,f+Shift1) - iADX(NULL,MTF1,Period1,Price1,MODE_MINUSDI,f+Shift1);
                               BUF2[i] = iADX(NULL,MTF2,Period2,Price2,MODE_PLUSDI,s+Shift2) - iADX(NULL,MTF2,Period2,Price2,MODE_MINUSDI,s+Shift2); }
     //---
     if (Calculation==ATR)   { BUF1[i] = iATR(NULL,MTF1,Period1,f+Shift1);
                               BUF2[i] = iATR(NULL,MTF2,Period2,s+Shift2); }
     //---
     if (Calculation==Bears) { BUF1[i] = iBearsPower(NULL,MTF1,Period1,Price1,f+Shift1);
                               BUF2[i] = iBearsPower(NULL,MTF2,Period2,Price2,s+Shift2); }
     //---
     if (Calculation==Bulls) { BUF1[i] = iBullsPower(NULL,MTF1,Period1,Price1,f+Shift1);
                               BUF2[i] = iBullsPower(NULL,MTF2,Period2,Price2,s+Shift2); }
     //---
     if (Calculation==CCI)   { BUF1[i] = iCCI(NULL,MTF1,Period1,Price1,f+Shift1);   
                               BUF2[i] = iCCI(NULL,MTF2,Period2,Price2,s+Shift2); }
     //---
     if (Calculation==DMR)   { BUF1[i] = iDeMarker(NULL,MTF1,Period1,f+Shift1);
                               BUF2[i] = iDeMarker(NULL,MTF2,Period2,s+Shift2); }
     //---
     if (Calculation==Force) { BUF1[i] = iForce(NULL,MTF1,Period1,Method1,Price1,f+Shift1);
                               BUF2[i] = iForce(NULL,MTF2,Period2,Method2,Price2,s+Shift2); }
     //---
     if (Calculation==MA)    { BUF1[i] = iMA(NULL,MTF1,Period1,Shift1,Method1,Price1,f);
                               BUF2[i] = iMA(NULL,MTF2,Period2,Shift2,Method2,Price2,s); }
     //---
     if (Calculation==OCLH)  { BUF1[i] = (iMA(NULL,MTF1,Period1,Shift1,Method1,PRICE_OPEN,f) + iMA(NULL,MTF1,Period1,Shift1,Method1,PRICE_CLOSE,f) + iMA(NULL,MTF1,Period1,Shift1,Method1,PRICE_LOW,f) + iMA(NULL,MTF1,Period1,Shift1,Method1,PRICE_HIGH,f)) /4;
                               BUF2[i] = (iMA(NULL,MTF2,Period2,Shift2,Method2,PRICE_OPEN,s) + iMA(NULL,MTF2,Period2,Shift2,Method2,PRICE_CLOSE,s) + iMA(NULL,MTF2,Period2,Shift2,Method2,PRICE_LOW,s) + iMA(NULL,MTF2,Period2,Shift2,Method2,PRICE_HIGH,s)) /4; }
     //---
     if (Calculation==DPO)   { BUF1[i] = iClose(NULL,MTF1,f) - iMA(NULL,MTF1,Period1,Period1/2+1,Method1,Price1,f);
                               BUF2[i] = iClose(NULL,MTF2,s) - iMA(NULL,MTF2,Period2,Period2/2+1,Method2,Price2,s); }
     //---
     if (Calculation==MFI)   { BUF1[i] = iMFI(NULL,MTF1,Period1,f+Shift1);
                               BUF2[i] = iMFI(NULL,MTF2,Period2,s+Shift2); }
     //---
     if (Calculation==BWMFI) { BUF1[i] = iBWMFI(NULL,MTF1,f+Shift1);
                               BUF2[i] = iBWMFI(NULL,MTF2,s+Shift2); }
     //---
     if (Calculation==MMNT)  { BUF1[i] = iMomentum(NULL,MTF1,Period1,Price1,f+Shift1);
                               BUF2[i] = iMomentum(NULL,MTF2,Period2,Price2,s+Shift2); }
     //---
     if (Calculation==OBV)   { BUF1[i] = iOBV(NULL,MTF1,Price1,f+Shift1);
                               BUF2[i] = iOBV(NULL,MTF2,Price2,s+Shift2); }
     //---
     if (Calculation==RSI)   { BUF1[i] = iRSI(NULL,MTF1,Period1,Price1,f+Shift1);
                               BUF2[i] = iRSI(NULL,MTF2,Period2,Price2,s+Shift2); }
     //---
     if (Calculation==RVI)   { BUF1[i] = iRVI(NULL,MTF1,Period1,MODE_MAIN,f+Shift1);
                               BUF2[i] = iRVI(NULL,MTF2,Period2,MODE_MAIN,s+Shift2); }
     //---
     if (Calculation==STD)   { BUF1[i] = iStdDev(NULL,MTF1,Period1,Shift1,Method1,Price1,f);
                               BUF2[i] = iStdDev(NULL,MTF2,Period2,Shift2,Method2,Price2,s); }
     //---
     if (Calculation==WPR)   { BUF1[i] = iWPR(NULL,MTF1,Period1,f+Shift1);
                               BUF2[i] = iWPR(NULL,MTF2,Period2,s+Shift2); }

//---
    } //* * for (int i=limit; i >= 0; i--) 
//+++======================================================================+++
//+++                   21x2 Indexes +2xMA MTF TT Eng                      +++
//+++======================================================================+++

   for (i=limit; i >= 0; i--)   
    { 
     if (SigMA1==0)  MA1[i]=0;    if (SigMA2==0)  MA2[i]=0; 
     //---
     MA1[i] = iMAOnArray(BUF1,0,SigMA1,MA1Shift,MA1Method,i);   
     MA2[i] = iMAOnArray(BUF2,0,SigMA2,MA2Shift,MA2Method,i);   
    }  
     

//----
return(0);
}
//+++======================================================================+++
//+++                   21x2 Indexes +2xMA MTF TT Eng                      +++
//+++======================================================================+++
string WichPeriod(int per)
{
   if (per == 0)     per=Period();
   if (per == 1)     return("M1");
   if (per == 5)     return("M5");
   if (per == 15)    return("M15");
   if (per == 30)    return("M30");
   if (per == 60)    return("H1");
   if (per == 240)   return("H4");
   if (per == 1440)  return("D1");
   if (per == 10080) return("W1");
   if (per == 43200) return("MN1");
   return(" ");
}
//+++======================================================================+++
//+++                   21x2 Indexes +2xMA MTF TT Eng                      +++
//+++======================================================================+++